#ifndef __VPCALC_MEMORY_H
#define __VPCALC_MEMORY_H

#ifndef PERM_READ
#define PERM_READ	0x0001
#define PERM_WRITE	0x0002
#define PERM_EXEC	0x0004
#endif

typedef void *memory_o;

memory_o memory_new(void);
void memory_del(memory_o memory);

size_t memory_size(memory_o memory);
size_t memory_bus_size(memory_o memory);

void memory_putimage(memory_o memory, void *data);
void memory_getimage(memory_o memory, void *data);

uint memory_fetch(memory_o memory, uint addr);
uint memory_read(memory_o memory, uint addr);
void memory_write(memory_o memory, uint addr, uint data);

uint8 memory_fetch_byte(memory_o memory, uint addr);
uint8 memory_read_byte(memory_o memory, uint addr);
void memory_write_byte(memory_o memory, uint addr, uint8 data);

void memory_remap(memory_o memory, uint page, uint addr, uint perm);
int memory_raw(memory_o memory, void **rd_ptr, void **wr_ptr, void **ex_ptr);

#endif
